<?php

require_once('../etc/runtime.conf.php');
require_once(PHPRPG_DIR.'/lib/auth.lib.php');
require_once(PHPRPG_DIR.'/lib/character.lib.php');

header('Content-type: text/javascript');

$objAuth = new AUTHENTICATE();

// Check if user has logged in
if ($objAuth->userCheck() === false) exit;

unset($objAuth);

$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
$errObj = new ERROR_REPORTER();

$charId = $_SESSION['PHPRPG']['CharId'];

if ($charId > 0) {

	$character = new CHARACTER($charId);

	$sides = PHPRPG_URL.'/share/images/bar_side.png';

	echo "\n oStart = document.createElement(\"IMG\");";
	echo "\n oStart.setAttribute(\"src\",    \"$sides\");";
	echo "\n oStart.setAttribute(\"width\",  \"1\");";
	echo "\n oStart.setAttribute(\"height\", \"7\");";
	echo "\n oStart.setAttribute(\"border\", \"0\");";

	echo "\n oEnd = document.createElement(\"IMG\");";
	echo "\n oEnd.setAttribute(\"src\",    \"$sides\");";
	echo "\n oEnd.setAttribute(\"width\",  \"1\");";
	echo "\n oEnd.setAttribute(\"height\", \"7\");";
	echo "\n oEnd.setAttribute(\"border\", \"0\");";


	echo "\n oPlayerName = document.getElementById(\"player-qstats-name\");";
	echo "\n while (oPlayerName.hasChildNodes()) oPlayerName.removeChild(oPlayerName.lastChild);";
	echo "\n oNameNode = document.createTextNode(\"$character->name\");";
	echo "\n oPlayerName.appendChild(oNameNode);";

	echo "\n oCurHP      = document.getElementById(\"player-qstats-curhp\");";
	echo "\n while (oCurHP.hasChildNodes()) oCurHP.removeChild(oCurHP.lastChild);";
	echo "\n oCurHPNode = document.createTextNode(\"".$character->hp['cur']."\");";
	echo "\n oCurHP.appendChild(oCurHPNode);";

	echo "\n oMaxHP      = document.getElementById(\"player-qstats-maxhp\");";
	echo "\n while (oMaxHP.hasChildNodes()) oMaxHP.removeChild(oMaxHP.lastChild);";
	echo "\n oNode = document.createTextNode(\"".$character->hp['max']."\");";
	echo "\n oMaxHP.appendChild(oNode);";

	{
		echo "\n oHPGraph    = document.getElementById(\"player-qstats-hpgraph\");";
		echo "\n while (oHPGraph.hasChildNodes()) oHPGraph.removeChild(oHPGraph.lastChild);";
		echo "\n oBar = document.createElement(\"DIV\");";

		if ($character->hp['max'] < 1) $character->hp['max'] = 1;

		$bar_percentage = (($character->hp['cur'] / $character->hp['max']) * 100);

		$bar_empty = PHPRPG_URL.'/share/images/bar_empty.png';
		$bar_empty_width = (100 - $bar_percentage);

		$bar_coloured = PHPRPG_URL.'/share/images/bar_green.png';
		$bar_coloured_width = $bar_percentage;

		echo "\n oEmpty = document.createElement(\"IMG\");";
		echo "\n oEmpty.setAttribute(\"src\",    \"$bar_empty\");";
		echo "\n oEmpty.setAttribute(\"width\",  \"$bar_empty_width\");";
		echo "\n oEmpty.setAttribute(\"height\", \"7\");";
		echo "\n oEmpty.setAttribute(\"border\", \"0\");";

		echo "\n oFull = document.createElement(\"IMG\");";
		echo "\n oFull.setAttribute(\"src\",    \"$bar_coloured\");";
		echo "\n oFull.setAttribute(\"width\",  \"$bar_coloured_width\");";
		echo "\n oFull.setAttribute(\"height\", \"7\");";
		echo "\n oFull.setAttribute(\"border\", \"0\");";

		echo "\n oBar.appendChild(oStart.cloneNode(true));";
		echo "\n oBar.appendChild(oEmpty);";
		echo "\n oBar.appendChild(oFull);";
		echo "\n oBar.appendChild(oEnd.cloneNode(true));";

		echo "\n oHPGraph.appendChild(oBar);";
	}

	echo "\n oCurMana    = document.getElementById(\"player-qstats-curmana\");";
	echo "\n while (oCurMana.hasChildNodes()) oCurMana.removeChild(oCurMana.lastChild);";
	echo "\n oNode = document.createTextNode(\"".$character->mana['cur']."\");";
	echo "\n oCurMana.appendChild(oNode);";

	echo "\n oMaxMana    = document.getElementById(\"player-qstats-maxmana\");";
	echo "\n while (oMaxMana.hasChildNodes()) oMaxMana.removeChild(oMaxMana.lastChild);";
	echo "\n oNode = document.createTextNode(\"".$character->mana['max']."\");";
	echo "\n oMaxMana.appendChild(oNode);";

	{
		echo "\n oManaGraph  = document.getElementById(\"player-qstats-managraph\");";
		echo "\n while (oManaGraph.hasChildNodes()) oManaGraph.removeChild(oManaGraph.lastChild);";
		echo "\n oBar = document.createElement(\"DIV\");";

		if ($character->mana['max'] < 1) $character->mana['max'] = 1;

		$bar_percentage = (($character->mana['cur'] / $character->mana['max']) * 100);

		$bar_empty  = PHPRPG_URL.'/share/images/bar_empty.png';
		$bar_empty_width  = (100 - $bar_percentage);

		$bar_coloured  = PHPRPG_URL.'/share/images/bar_red.png';
		$bar_coloured_width  = $bar_percentage;

		echo "\n oEmpty = document.createElement(\"IMG\");";
		echo "\n oEmpty.setAttribute(\"src\",    \"$bar_empty\");";
		echo "\n oEmpty.setAttribute(\"width\",  \"$bar_empty_width\");";
		echo "\n oEmpty.setAttribute(\"height\", \"7\");";
		echo "\n oEmpty.setAttribute(\"border\", \"0\");";

		echo "\n oFull = document.createElement(\"IMG\");";
		echo "\n oFull.setAttribute(\"src\",    \"$bar_coloured\");";
		echo "\n oFull.setAttribute(\"width\",  \"$bar_coloured_width\");";
		echo "\n oFull.setAttribute(\"height\", \"7\");";
		echo "\n oFull.setAttribute(\"border\", \"0\");";

		echo "\n oBar.appendChild(oStart.cloneNode(true));";
		echo "\n oBar.appendChild(oEmpty);";
		echo "\n oBar.appendChild(oFull);";
		echo "\n oBar.appendChild(oEnd.cloneNode(true));";

		echo "\n oManaGraph.appendChild(oBar);";
	}

	echo "\n oCurStam    = document.getElementById(\"player-qstats-curstam\");";
	echo "\n while (oCurStam.hasChildNodes()) oCurStam.removeChild(oCurStam.lastChild);";
	echo "\n oNode = document.createTextNode(\"".$character->stm['cur']."\");";
	echo "\n oCurStam.appendChild(oNode);";

	echo "\n oMaxStam    = document.getElementById(\"player-qstats-maxstam\");";
	echo "\n while (oMaxStam.hasChildNodes()) oMaxStam.removeChild(oMaxStam.lastChild);";
	echo "\n oNode = document.createTextNode(\"".$character->stm['max']."\");";
	echo "\n oMaxStam.appendChild(oNode);";

	{
		echo "\n oStamGraph  = document.getElementById(\"player-qstats-stamgraph\");";
		echo "\n while (oStamGraph.hasChildNodes()) oStamGraph.removeChild(oStamGraph.lastChild);";
		echo "\n oBar = document.createElement(\"DIV\");";

		if ($character->stm['max'] < 1) $character->stm['max'] = 1;

		$bar_percentage = (($character->stm['cur'] / $character->stm['max']) * 100);

		$bar_empty  = PHPRPG_URL.'/share/images/bar_empty.png';
		$bar_empty_width  = (100 - $bar_percentage);

		$bar_coloured  = PHPRPG_URL.'/share/images/bar_yellow.png';
		$bar_coloured_width  = $bar_percentage;

		echo "\n oEmpty = document.createElement(\"IMG\");";
		echo "\n oEmpty.setAttribute(\"src\",    \"$bar_empty\");";
		echo "\n oEmpty.setAttribute(\"width\",  \"$bar_empty_width\");";
		echo "\n oEmpty.setAttribute(\"height\", \"7\");";
		echo "\n oEmpty.setAttribute(\"border\", \"0\");";

		echo "\n oFull = document.createElement(\"IMG\");";
		echo "\n oFull.setAttribute(\"src\",    \"$bar_coloured\");";
		echo "\n oFull.setAttribute(\"width\",  \"$bar_coloured_width\");";
		echo "\n oFull.setAttribute(\"height\", \"7\");";
		echo "\n oFull.setAttribute(\"border\", \"0\");";

		echo "\n oBar.appendChild(oStart.cloneNode(true));";
		echo "\n oBar.appendChild(oEmpty);";
		echo "\n oBar.appendChild(oFull);";
		echo "\n oBar.appendChild(oEnd.cloneNode(true));";

		echo "\n oStamGraph.appendChild(oBar);";
	}

	echo "\n oCurrency   = document.getElementById(\"player-qstats-currency\");";
	echo "\n while (oCurrency.hasChildNodes()) oCurrency.removeChild(oCurrency.lastChild);";
	echo "\n oNode = document.createTextNode(\"".number_format($character->currency)."\");";
	echo "\n oCurrency.appendChild(oNode);";

	echo "\n oExperience = document.getElementById(\"player-qstats-xp\");";
	echo "\n while (oExperience.hasChildNodes()) oExperience.removeChild(oExperience.lastChild);";
	echo "\n oNode = document.createTextNode(\"".number_format($character->experience)."\");";
	echo "\n oExperience.appendChild(oNode);";
}
// DO REAL ERROR REPORTING

$dbObj->flush();

?>



