<?php

function drawCharacterEditor() {

	// DRAW HEADER INFORMATION
	$page  = new TEMPLATE('page');
	$olObj = new Overlib(PHPRPG_URL.'/lib/js');
	$context_header = $olObj->init();
	$char_editors   = "<div id='tool-box' name='tool-box'> \n";

	$header_extras  = '<script type="text/javascript" language="JavaScript" src="'.PHPRPG_URL.'/lib/js/character.js.php"></script>';
	$header_extras .= '<script type="text/javascript" language="JavaScript" src="'.PHPRPG_URL.'/lib/js/scriptload.js"></script>';



	// ATTRIBUTE EDITOR
	$char_editors  .= "<div class='editor' id='char-editor-attrib' name='char-editor-attrib'>";

	$attrib_filter_input = "<input type='input' class='input' id='attrib-filter-input' name='attrib-filter-input'>";

	$context = $olObj->over('Filter the number of visable results.', 'Filter');
	$javascript = 'onClick="attribFilter();"';
	$attrib_filter_button = "<input type='button' class='inputbutton' id='attrib-filter-button' name='attrib-filter-button' value='Filter' $context $javascript>";

	$context = $olObj->over('Add new attribute to this tile.', 'New Attribute');
	$url = "'".PHPRPG_URL."/characters.php?submit=Edit+Attributes&char-id='+iChar";
	$javascript = "onClick=\"doPopup($url,'Edit_Attributes',525,350,0);\"";
	$attrib_new_button = "<input type='button' class='inputbutton' id='attrib-new-button' name='attrib-new-button' value='New Attribute' $context $javascript>";

	$attrib_table = '<div id="attribute-div" name="attribute-div"><table id="attribute-table" name="attribute-table"></table></div>';

	$page->define('ATTRIB_FILTER_INPUT',  $attrib_filter_input);
	$page->define('ATTRIB_FILTER_BUTTON', $attrib_filter_button);
	$page->define('ATTRIB_NEW_BUTTON',    $attrib_new_button);
	$page->define('ATTRIB_TABLE',         $attrib_table);

	$char_editors .= $page->build('admin_character_attrib');
	$char_editors .= '</div>';

	$page->flush();



	// PORTRAIT IMAGE REPOSITORY
	$char_editors .= "<div class='editor' id='char-editor-portrait' name='char-editor-portrait'>";

	$context = $olObj->over('Scan the host for new images in the portrait directory.', 'Scan');
	$javascript = "onClick=\"scanImages();\"";
	$image_scan_button = "<input type='button' class='inputbutton' id='portrait-scan-button' name='portrait-scan-button' value='Scan' $context $javascript>";

	$context = $olObj->over('Upload a number of images to the portrait image directory.', 'Upload');
	$javascript = "onClick=\"uploadImages();\"";
	$image_upload_button = "<input type='button' class='inputbutton' id='portrait-image-button' name='portrait-image-button' value='Upload' $context $javascript>";

	$javascript = "onChange='showImages(this);'";
	$image_set_select  = "<select class='input' id='portrait-set-select' name='portrait-set-select' $javascript>";
	$image_set_select .= "<option value=''>Unsorted</option>";
	$image_set_select .= "</select>";

	$context = $olObj->over('Organize the available images.', '...');
	$javascript = "onClick=\"editImageSet();\"";
	$image_set_editor_button = "<input type='button' class='inputbutton' id='portrait-set-editor-button' value='...' $context $javascript>";

	$images_in_set = '<div id="portrait-palette" name="portrait-palette"></div>';

	$page->define('IMAGE_SCAN_BUTTON',       $image_scan_button);
	$page->define('UPLOAD_IMAGE_BUTTON',     $image_upload_button);
	$page->define('IMAGE_SET_SELECT',        $image_set_select);
	$page->define('IMAGE_SET_EDITOR_BUTTON', $image_set_editor_button);
	$page->define('IMAGES_IN_SET',           $images_in_set);

	$char_editors .= $page->build('admin_character_portrait');
	$char_editors .= "</div>";

	$page->flush();



	// DRAW IMAGE REPOSITORIES
	$char_editors  .= "<div class='editor' id='char-editor-sprite' name='char-editor-sprite'>";

	$context = $olObj->over('Scan the host for new images in the item image directory.', 'Scan');
	$javascript = "onClick=\"scanImages();\"";
	$image_scan_button = "<input type='button' class='inputbutton' id='image-scan-button' value='Scan' $context $javascript>";

	$context = $olObj->over('Upload a number of images to the item image directory.', 'Upload');
	$javascript = "onClick=\"uploadImages();\"";
	$upload_image_button = "<input type='button' class='inputbutton' id='upload-image-button' value='Upload' $context $javascript>";

	$javascript = "onChange='showImages(this);'";
	$image_set_select  = "<select class='input' id='image-set-select' $javascript>";
	$image_set_select .= "<option value=''>Unsorted</option>";
	$image_set_select .= "</select>";

	$context = $olObj->over('Organize the available images.', '...');
	$javascript = "onClick=\"editImageSet();\"";
	$image_set_editor_button = "<input type='button' class='inputbutton' id='image-set-editor-button' value='...' $context $javascript>";

	$images_type_select  = "<input type='radio' id='image-type-body' name='image-type-body' onClick=\"editorSelect('body');\"> Body";
	$images_type_select .= "<input type='radio' id='image-type-hair' name='image-type-hair' onClick=\"editorSelect('hair');\"> Hair";
	$images_type_select .= "<input type='radio' id='image-type-wings' name='image-type-wings' onClick=\"editorSelect('wings');\"> Wings";
	$images_type_select .= "<input type='radio' id='image-type-tail' name='image-type-tail' onClick=\"editorSelect('tail');\"> Tail";

	$images_in_set = '<div id="image-palette" name="image-palette"></div>';

	$page->define('IMAGE_SCAN_BUTTON',         $image_scan_button);
	$page->define('UPLOAD_IMAGE_BUTTON',       $upload_image_button);
	$page->define('IMAGE_SET_SELECT',          $image_set_select);
	$page->define('IMAGE_SET_EDITOR_BUTTON',   $image_set_editor_button);
	$page->define('IMAGES_IN_SET',             $images_in_set);
	$page->define('IMAGE_TYPE_RADIO_BUTTONS',  $images_type_select);

	$char_editors .= $page->build('admin_item_image');
	$char_editors .= '</div>';

	$page->flush();



	// DRAW CHARACTER EDITOR
	$form_header = "<form action='".PHPRPG_URL."/characters.php'>";

	$char_search_input  = "<input type='text' class='input' id='char-search-input' name='char-search-input'>";

	$context = $olObj->over('Find characters in game using a name based search, use % for wildcards.', 'Search');
	$javascript = "onClick='searchChar()'";
	$char_search_button = "<input type='button' class='inputbutton' id='char-search-button' value='Search' $context $javascript>";

	$javascript = "onChange='editorSelect(this.options[this.selectedIndex].value)'";
	$char_editor_select  = "<select class='input' id='char-editor-select' name='char-editor-select' $javascript>";
	$char_editor_select .= "<option value='none'>-- select sub editor --</option>";
	$char_editor_select .= "<option value='attrib'> Attribute Editor </option>";
	$char_editor_select .= "<option value='portrait'> Portrait Editor </option>";
	$char_editor_select .= "<option value='body'> Sprite Editor </option>";
	$char_editor_select .= "</select>";

	$char_image_sprite   = "<img id='char-image-sprite'   name='char-image-sprite'   width='256' height='256'>";
	$char_image_portrait = "<img id='char-image-portrait' name='char-image-portrait' width='128' height='128'>";
	$char_image_head     = "<img id='char-image-head'     name='char-image-head'     width='32' height='32'>";
	$char_image_neck     = "<img id='char-image-neck'     name='char-image-neck'     width='32' height='32'>";
	$char_image_chest    = "<img id='char-image-chest'    name='char-image-chest'    width='32' height='32'>";
	$char_image_legs     = "<img id='char-image-legs'     name='char-image-legs'     width='32' height='32'>";
	$char_image_belt     = "<img id='char-image-belt'     name='char-image-belt'     width='32' height='32'>";
	$char_image_rhand    = "<img id='char-image-rhand'    name='char-image-rhand'    width='32' height='32'>";
	$char_image_lhand    = "<img id='char-image-lhand'    name='char-image-lhand'    width='32' height='32'>";
	$char_image_lring    = "<img id='char-image-lring'    name='char-image-lring'    width='32' height='32'>";
	$char_image_rring    = "<img id='char-image-rring'    name='char-image-rring'    width='32' height='32'>";
	$char_image_feet     = "<img id='char-image-feet'     name='char-image-feet'     width='32' height='32'>";

	// Draw Statistics
	$javascript = "onChange='return formChange()'";
	$char_userid_text = "<input type='text' class='input' id='char-userid-input'  name='char-userid-input' size='3' $javascript>";

	$context = $olObj->over('Edit information on this user.', '...');
	$url = "'".PHPRPG_URL."/characters.php?submit=User+Editor&user-id='+iUser+'&action=&user-filter-new=1'";
	$javascript = "onClick=\"if (checkForm()) doPopup($url,'Edit_User',450,315);\"";
	$char_userid_button = "<input type='button' class='inputbutton' id='char-userid-button' name='char-userid-button' value='...' $context $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_name_input = "<input type='text' class='input' id='char-name-input'  name='char-name-input' size='16' $javascript>";

	$context = $olObj->over('Change color information on this user.', '...');
	$url = "'".PHPRPG_URL."/characters.php?submit=Colour+Editor&char-id='+iChar";
	$javascript = "onClick=\"if (checkForm()) doPopup($url,'Colour_User',450,275);\"";
	$char_colour_button = "<input type='button' class='inputbutton' id='char-colour-button' name='char-colour-button' value='...' $context $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_str_input = "<input type='text' class='input' id='char-str-input'  name='char-str-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_vit_input = "<input type='text' class='input' id='char-vit-input'  name='char-vit-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_agl_input = "<input type='text' class='input' id='char-agl-input'  name='char-agl-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_int_input = "<input type='text' class='input' id='char-int-input'  name='char-int-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_wis_input = "<input type='text' class='input' id='char-wis-input'  name='char-wis-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_chr_input = "<input type='text' class='input' id='char-chr-input'  name='char-chr-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_age_input = "<input type='text' class='input' id='char-age-input'  name='char-age-input' size='3' $javascript>";

	$context = $olObj->over('Save the current character.', 'Save');
	$javascript = "onClick='saveChar()'";
	$char_save_button = "<input type='button' class='inputbutton' id='char-save-button' value='Save' $context $javascript>";

	$context = $olObj->over('Save the currect character as a new character.', 'SaveAs');
	$javascript = "onClick='saveChar(true)'";
	$char_saveas_button = "<input type='button' class='inputbutton' id='char-saveas-button' value='Save As' $context $javascript>";

	$context = $olObj->over('Create a new character.', 'New');
	$javascript = "onClick='clearChar()'";
	$char_new_button = "<input type='button' class='inputbutton' id='char-new-button' value='New' $context $javascript>";

	$context = $olObj->over('Delete the current character.', 'Delete');
	$javascript = "onClick='deleteChar()'";
	$char_delete_button = "<input type='button' class='inputbutton' id='char-delete-button' value='Delete' $context $javascript>";

	// Draw Variable Statistics
	$javascript = "onChange='return formChange()'";
	$char_krm_input = "<input type='text' class='input' id='char-krm-input'  name='char-krm-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_ac_input = "<input type='text' class='input' id='char-ac-input'  name='char-ac-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_hpcur_input = "<input type='text' class='input' id='char-hpcur-input'  name='char-hpcur-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_hpmax_input = "<input type='text' class='input' id='char-hpmax-input'  name='char-hpmax-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_stmcur_input = "<input type='text' class='input' id='char-stmcur-input'  name='char-stmcur-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_stmmax_input = "<input type='text' class='input' id='char-stmmax-input'  name='char-stmmax-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_manacur_input = "<input type='text' class='input' id='char-manacur-input'  name='char-manacur-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_manamax_input = "<input type='text' class='input' id='char-manamax-input'  name='char-manamax-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_capcur_input = "<input type='text' class='input' id='char-capcur-input'  name='char-capcur-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_capmax_input = "<input type='text' class='input' id='char-capmax-input'  name='char-capmax-input' size='3' $javascript>";

	$javascript = "onChange='return formChange()'";
	$char_size_select  = "<select class='input' id='char-size-select' name='char-size-select' $javascript>";
	$char_size_select .= "<option value='0'>Microscopic</option>";
	$char_size_select .= "<option value='1'>Tiny</option>";
	$char_size_select .= "<option value='2'>Small</option>";
	$char_size_select .= "<option value='3'>Normal</option>";
	$char_size_select .= "<option value='4'>Large</option>";
	$char_size_select .= "<option value='5'>Huge</option>";
	$char_size_select .= "<option value='6'>Gigantic</option>";
	$char_size_select .= "</select>";

	$char_editors .= "</div>";

	$page->define('TITLE',                 'PHPRPG Admin - Character Editor');
	$page->define('HEADER_EXTRAS',        $header_extras);
	$page->define('PROGRAM_NAME',          'Character Editor ::');
	$page->define('ADMIN_MENU',            drawMenu(TRUE));
	$page->define('CONTEXT_HEADER',       $context_header);
	$page->define('ERROR',                 '');
	$page->define('FORM_HEADER',          $form_header);
	$page->define('CHAR_SEARCH_INPUT',    $char_search_input);
	$page->define('CHAR_SEARCH_BUTTON',   $char_search_button);
	$page->define('CHAR_EDITOR_SELECT',   $char_editor_select);
	$page->define('CHAR_USERID_INPUT',    $char_userid_text);
	$page->define('CHAR_USERID_BUTTON',   $char_userid_button);
	$page->define('CHAR_COLOUR_BUTTON',   $char_colour_button);
	$page->define('CHAR_HPCUR_INPUT',     $char_hpcur_input);
	$page->define('CHAR_HPMAX_INPUT',     $char_hpmax_input);
	$page->define('CHAR_STMCUR_INPUT',    $char_stmcur_input);
	$page->define('CHAR_STMMAX_INPUT',    $char_stmmax_input);
	$page->define('CHAR_MANACUR_INPUT',   $char_manacur_input);
	$page->define('CHAR_MANAMAX_INPUT',   $char_manamax_input);
	$page->define('CHAR_CAPCUR_INPUT',    $char_capcur_input);
	$page->define('CHAR_CAPMAX_INPUT',    $char_capmax_input);
	$page->define('CHAR_SIZE_SELECT',     $char_size_select);
	$page->define('CHAR_STR_INPUT',       $char_str_input);
	$page->define('CHAR_VIT_INPUT',       $char_vit_input);
	$page->define('CHAR_AGL_INPUT',       $char_agl_input);
	$page->define('CHAR_INT_INPUT',       $char_int_input);
	$page->define('CHAR_WIS_INPUT',       $char_wis_input);
	$page->define('CHAR_CHR_INPUT',       $char_chr_input);
	$page->define('CHAR_NAME_INPUT',      $char_name_input);
	$page->define('CHAR_IMAGE_SPRITE',    $char_image_sprite);
	$page->define('CHAR_IMAGE_PORTRAIT',  $char_image_portrait);
	$page->define('CHAR_IMAGE_HEAD',      $char_image_head);
	$page->define('CHAR_IMAGE_NECK',      $char_image_neck);
	$page->define('CHAR_IMAGE_RHAND',     $char_image_rhand);
	$page->define('CHAR_IMAGE_LHAND',     $char_image_lhand);
	$page->define('CHAR_IMAGE_LRING',     $char_image_lring);
	$page->define('CHAR_IMAGE_RRING',     $char_image_rring);
	$page->define('CHAR_IMAGE_CHEST',     $char_image_chest);
	$page->define('CHAR_IMAGE_LEGS',      $char_image_legs);
	$page->define('CHAR_IMAGE_BELT',      $char_image_belt);
	$page->define('CHAR_IMAGE_FEET',      $char_image_feet);
	$page->define('CHAR_AGE_INPUT',       $char_age_input);
	$page->define('CHAR_KRM_INPUT',       $char_krm_input);
	$page->define('CHAR_AC_INPUT',        $char_ac_input);
	$page->define('CHAR_SAVE_BUTTON',     $char_save_button);
	$page->define('CHAR_SAVEAS_BUTTON',   $char_saveas_button);
	$page->define('CHAR_NEW_BUTTON',      $char_new_button);
	$page->define('CHAR_DELETE_BUTTON',   $char_delete_button);
	$page->define('CHAR_EDITORS',         $char_editors);

	return($page->build('admin_characters'));
}


?>