<?php

if (!defined('PHPRPG_ATTRIBUTES')) define('PHPRPG_ATTRIBUTES', true);

require_once(PHPRPG_DIR.'/lib/error.lib.php');
require_once(PHPRPG_DIR.'/lib/mysql.lib.php');

class ATTRIBUTES
{
//PUBLIC:
	var $errors;

	function get($key='') {

		$key = empty($key) ? '%' : trim($key);

		if (empty($this->iclass) && empty($this->itarg)) return(false);

		$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
		$errObj = new ERROR_REPORTER();

		$rtn = NULL;

		$table = $this->sqlinfo[$this->iclass]['table'];
		$col   = $this->sqlinfo[$this->iclass]['col'];

		$table = PHPRPG_DB_PREFIX.$table;
		$sql  = 'SELECT '.$col.'Key,'.$col.'Value,'.$col.'Death ';
		$sql .= "FROM $table WHERE ".$col."Key='$key' AND ".$col."Target='$this->itarg'";

		if (!$dbObj->query($sql)) $this->errors[] = $errObj->report(PHPRPG_ERR_ERROR, $dbObj->error, __FILE__, __LINE__);
		if ($row = mysql_fetch_array($dbObj->result)) {
			do $rtn = array('Key' => $row[$col.'Key'], 'Value' => $row[$col.'Value'], 'Death'=>$row[$col.'Death']);
			while($row = mysql_fetch_array($dbObj->result));
		}
		$dbObj->flush();

		if (empty($this->errors)) return($rtn);
		return(false);
	}

	function add($key,$value,$death=0) {

		$key   = trim($key);
		$value = trim($value);
		$death = intval($death);

		if (empty($this->iclass) && empty($this->itarg)) return(false);

		$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
		$errObj = new ERROR_REPORTER();

		$this->errors = NULL;

		$table = $this->sqlinfo[$this->iclass]['table'];
		$col   = $this->sqlinfo[$this->iclass]['col'];

		$table = PHPRPG_DB_PREFIX.$table;
		$sql  = "INSERT INTO $table (".$col."Key,".$col."Value,".$col."Target,".$col."Death)";
		$sql .= " VALUES ('$key','$value','$this->itarg',$death)";
		if (!$dbObj->command($sql)) $this->errors[] = $errObj->report(PHPRPG_ERR_ERROR, $dbObj->error, __FILE__, __LINE__);

		if (empty($this->errors)) return(true);
		return(false);
	}

	function mod($old,$key='',$value='',$death=0) {

		$old   = trim($old);
		$key   = trim($key);
		$value = trim($value);
		$death = intval($death);

		if (empty($this->iclass) && empty($this->itarg)) return(false);

		$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
		$errObj = new ERROR_REPORTER();

		$this->errors = NULL;

		if (empty($key) && empty($value) && empty($death)) return(false);

		$table = $this->sqlinfo[$this->iclass]['table'];
		$col   = $this->sqlinfo[$this->iclass]['col'];

		$table = PHPRPG_DB_PREFIX.$table;
		$sql  = "UPDATE $table SET ";

		if (!empty($key))   $sql .= $col."Key='$key',";
		if (!empty($value)) $sql .= $col."Value='$value',";
		if (!empty($death)) $sql .= $col."Death='$death',";

		$sql .= $col."Target='$this->itarg' WHERE ".$col."Key='$old'";
		if (!$dbObj->command($sql)) $this->errors[] = $errObj->report(PHPRPG_ERR_ERROR, $dbObj->error, __FILE__, __LINE__);

		if (empty($this->errors)) return(true);
		return(false);
	}

	function del($key) {

		if (empty($this->iclass) && empty($this->itarg)) return(false);

		$key   = trim($key);
		$table = $this->sqlinfo[$this->iclass]['table'];
		$col   = $this->sqlinfo[$this->iclass]['col'];

		$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
		$errObj = new ERROR_REPORTER();

		$this->errors = NULL;

		$table = PHPRPG_DB_PREFIX.$table;
		$sql  = "DELETE FROM $table WHERE ".$col."Key='$key'";

		if (!$dbObj->command($sql)) $this->errors[] = $errObj->report(PHPRPG_ERR_ERROR, $dbObj->error, __FILE__, __LINE__);

		if (empty($this->errors)) return(true);
		return(false);
	}

	function dump() {

		if (empty($this->iclass) && empty($this->itarg)) return(false);


		$dbObj  = new MYSQL(PHPRPG_DB_HOST,PHPRPG_DB_USER,PHPRPG_DB_PASS,PHPRPG_DB_NAME);
		$errObj = new ERROR_REPORTER();

		$rtn = NULL;

		$table = $this->sqlinfo[$this->iclass]['table'];
		$col   = $this->sqlinfo[$this->iclass]['col'];

		$table = PHPRPG_DB_PREFIX.$table;
		$sql  = 'SELECT '.$col.'Key,'.$col.'Value,'.$col.'Death ';
		$sql .= "FROM $table WHERE ".$col."Target='$this->itarg'";

		if (!$dbObj->query($sql)) $this->errors[] = $errObj->report(PHPRPG_ERR_ERROR, $dbObj->error, __FILE__, __LINE__);
		if ($row = mysql_fetch_array($dbObj->result)) {
			do $rtn[] = array('Key' => $row[$col.'Key'], 'Value' => $row[$col.'Value'], 'Death'=>$row[$col.'Death']);
			while($row = mysql_fetch_array($dbObj->result));
		}
		$dbObj->flush();

		if (empty($this->errors)) return($rtn);
		return(false);
	}

//PRIVATE:
	var $sqlinfo;
	var $itarg;
	var $iclass;

	function ATTRIBUTES($target,$class) {

		$this->sqlinfo[PHPRPG_CLASS_CHAR] = array('table'=>'_char_attrib', 'col'=>'CharAttrib');
		$this->sqlinfo[PHPRPG_CLASS_ITEM] = array('table'=>'_item_attrib', 'col'=>'ItemAttrib');
		$this->sqlinfo[PHPRPG_CLASS_TILE] = array('table'=>'_tile_attrib', 'col'=>'TileAttrib');

		$this->iclass = intval($class);
		$this->itarg  = intval($target);
		$this->errors = NULL;
	}
}


?>